;;
;; $Id: lua.h,v 1.218.1.5 2008/08/06 13:30:12 roberto Exp $
;; Lua - An Extensible Extension Language
;; Lua.org, PUC-Rio, Brazil (http://www.lua.org)
;; See Copyright Notice at the end of this file
;;


%ifndef lua_h
%define lua_h



%include "luaconf.inc"


%define LUA_VERSION	"Lua 5.1"
%define LUA_RELEASE	"Lua 5.1.4"
%define LUA_VERSION_NUM	501
%define LUA_COPYRIGHT	"Copyright (C) 1994-2008 Lua.org, PUC-Rio"
%define LUA_AUTHORS 	"R. Ierusalimschy, L. H. de Figueiredo & W. Celes"


;; mark for precompiled code (`<esc>Lua') ;;
%define	LUA_SIGNATURE	"\033Lua"

;; option for multiple returns in `lua_pcall' and `lua_call' ;;
%define LUA_MULTRET	(-1)


;;
;; pseudo-indices
;;
%define LUA_REGISTRYINDEX	(-10000)
%define LUA_ENVIRONINDEX	(-10001)
%define LUA_GLOBALSINDEX	(-10002)
%define lua_upvalueindex(i)	(LUA_GLOBALSINDEX-(i))


;; thread status; 0 is OK ;;
%define LUA_YIELD	1
%define LUA_ERRRUN	2
%define LUA_ERRSYNTAX	3
%define LUA_ERRMEM	4
%define LUA_ERRERR	5


%define LUA_TNONE		(-1)

%define LUA_TNIL		0
%define LUA_TBOOLEAN		1
%define LUA_TLIGHTUSERDATA	2
%define LUA_TNUMBER		3
%define LUA_TSTRING		4
%define LUA_TTABLE		5
%define LUA_TFUNCTION		6
%define LUA_TUSERDATA		7
%define LUA_TTHREAD		8



;; minimum Lua stack available to a C function ;;
%define LUA_MINSTACK	20


%define LUA_GCSTOP		0
%define LUA_GCRESTART		1
%define LUA_GCCOLLECT		2
%define LUA_GCCOUNT		3
%define LUA_GCCOUNTB		4
%define LUA_GCSTEP		5
%define LUA_GCSETPAUSE		6
%define LUA_GCSETSTEPMUL	7



;;
;; Event codes
;;
%define LUA_HOOKCALL	0
%define LUA_HOOKRET	1
%define LUA_HOOKLINE	2
%define LUA_HOOKCOUNT	3
%define LUA_HOOKTAILRET 4


;;
;; Event masks
;;
%define LUA_MASKCALL	(1 << LUA_HOOKCALL)
%define LUA_MASKRET	(1 << LUA_HOOKRET)
%define LUA_MASKLINE	(1 << LUA_HOOKLINE)
%define LUA_MASKCOUNT	(1 << LUA_HOOKCOUNT)




struc lua_Debug 
  .event: resd 1 ;
  .name: resd 1 ;	/* (n) */
  .namewhat: resd 1 ;	/* (n) `global', `local', `field', `method' */
  .what: resd 1 ;	/* (S) `Lua', `C', `main', `tail' */
  .source: resd 1 ;	/* (S) */
  .currentline: resd 1 ;	/* (l) */
  .nups: resd 1 ;		/* (u) number of upvalues */
  .linedefined: resd 1 ;	/* (S) */
  .lastlinedefined: resd 1 ;	/* (S) */
  .short_src: resb LUA_IDSIZE; /* (S) */
  ;; private part ;;
  .i_ci: resd 1 ;  /* active function */
endstruc

;; }====================================================================== ;;


;;*****************************************************************************
; Copyright (C) 1994-2008 Lua.org, PUC-Rio.  All rights reserved.
;
; Permission is hereby granted, free of charge, to any person obtaining
; a copy of this software and associated documentation files (the
; "Software"), to deal in the Software without restriction, including
; without limitation the rights to use, copy, modify, merge, publish,
; distribute, sublicense, and/or sell copies of the Software, and to
; permit persons to whom the Software is furnished to do so, subject to
; the following conditions:
;
; The above copyright notice and this permission notice shall be
; included in all copies or substantial portions of the Software.
;
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
; EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
; MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
; IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
; CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
; TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
; SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
;;*****************************************************************************/


%endif
